#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <pthread.h>
#include <errno.h>
#include "func_extern.h"
#include "motor.h"
#include "control.h"

pthread_t motor_task;
pthread_attr_t attr_motor;
struct sched_param sched_param;

int main(void){

	int spl;
	int spr;
	int i;
	int s_val;

	printf("left speed = ");
	s_val=scanf("%d",&spl);
	printf("riget speed = ");
	s_val=scanf("%d",&spr);
	printf("\n");

	printf("spl=%d, spr=%d\n",spl,spr);

	//pthread_mutex_init(mutex_m,NULL);

/*
	pthread_attr_init (&attr_motor);
	sched_param.sched_priority = 20;
	pthread_attr_setschedpolicy(&attr_motor, SCHED_RR);
	pthread_attr_setschedparam (&attr_motor, &sched_param);
*/

	printf("opening device...\n");
	fd1 = open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		if(errno == 3) printf("no such file\n");
		else if(errno == 13) printf("permission\n");
		else printf("other\n");
		fprintf(stderr, "fd1 open error\n");
		exit(-1);
	}
	fd2 = open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		fprintf(stderr, "fd2 open error\n");
		close(fd1);
		exit(-1);
	}
	printf("end\n");
		
	printf("starting...\n");

	//motor(c, val, t);

        motor_send_start_packet (fd1);
        motor_send_start_packet (fd2);
 
for(i=1;i<100;i++){
	motor_send_control_packet(fd1,spl,Kp,Ki);
	usleep(130000);
	motor_send_control_packet(fd2,spr,Kp,Ki);
	usleep(130000);
//	spl*=-1; spr*=-1;
	//spl+=5; spr+=5;
	//printf("spl=%d, spr=%d\n",spl,spr);
}
/*
	motor_send_control_packet(fd1,0,Kp,Ki);
	motor_send_control_packet(fd2,0,Kp,Ki);
*/

        motor_send_stop_packet (fd1);
        motor_send_stop_packet (fd2);
 
	printf("end\n");
	
	printf("closing device...\n");
	close(fd1);
	close(fd2);
	printf("end\n");
	printf("Finish!!\n");

	return 0;
}
